# This file was auto-generated by Fern from our API Definition.

import typing

import pydantic

from ....core.pydantic_utilities import IS_PYDANTIC_V2
from ....core.unchecked_base_model import UncheckedBaseModel
from .base_type import BaseType
from .strategy import Strategy


class BaseModel(UncheckedBaseModel):
    """
    The base model used for fine-tuning.
    """

    name: typing.Optional[str] = pydantic.Field(default=None)
    """
    The name of the base model.
    """

    version: typing.Optional[str] = pydantic.Field(default=None)
    """
    read-only. The version of the base model.
    """

    base_type: BaseType = pydantic.Field()
    """
    The type of the base model.
    """

    strategy: typing.Optional[Strategy] = pydantic.Field(default=None)
    """
    The fine-tuning strategy.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
