# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations

import typing

import pydantic
import typing_extensions

from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel, UnionMetadata
from .finish_reason import FinishReason
from .generate_stream_end_response import GenerateStreamEndResponse


class GenerateStreamedResponse_TextGeneration(UncheckedBaseModel):
    """
    Response in content type stream when `stream` is `true` in the request parameters. Generation tokens are streamed with the GenerationStream response. The final response is of type GenerationFinalResponse.
    """

    text: str
    index: typing.Optional[int] = None
    is_finished: bool
    event_type: typing.Literal["text-generation"] = "text-generation"

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


class GenerateStreamedResponse_StreamEnd(UncheckedBaseModel):
    """
    Response in content type stream when `stream` is `true` in the request parameters. Generation tokens are streamed with the GenerationStream response. The final response is of type GenerationFinalResponse.
    """

    is_finished: bool
    finish_reason: typing.Optional[FinishReason] = None
    response: GenerateStreamEndResponse
    event_type: typing.Literal["stream-end"] = "stream-end"

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


class GenerateStreamedResponse_StreamError(UncheckedBaseModel):
    """
    Response in content type stream when `stream` is `true` in the request parameters. Generation tokens are streamed with the GenerationStream response. The final response is of type GenerationFinalResponse.
    """

    index: typing.Optional[int] = None
    is_finished: bool
    finish_reason: FinishReason
    err: str
    event_type: typing.Literal["stream-error"] = "stream-error"

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


GenerateStreamedResponse = typing_extensions.Annotated[
    typing.Union[
        GenerateStreamedResponse_TextGeneration,
        GenerateStreamedResponse_StreamEnd,
        GenerateStreamedResponse_StreamError,
    ],
    UnionMetadata(discriminant="event_type"),
]
