# This file was auto-generated by Fern from our API Definition.

from __future__ import annotations

import typing

import pydantic
import typing_extensions

from ..core.pydantic_utilities import IS_PYDANTIC_V2
from ..core.unchecked_base_model import UncheckedBaseModel, UnionMetadata
from .tool_call import ToolCall
from .tool_result import ToolResult


class Message_Chatbot(UncheckedBaseModel):
    message: str
    tool_calls: typing.Optional[typing.List[ToolCall]] = None
    role: typing.Literal["CHATBOT"] = "CHATBOT"

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


class Message_System(UncheckedBaseModel):
    message: str
    tool_calls: typing.Optional[typing.List[ToolCall]] = None
    role: typing.Literal["SYSTEM"] = "SYSTEM"

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


class Message_User(UncheckedBaseModel):
    message: str
    tool_calls: typing.Optional[typing.List[ToolCall]] = None
    role: typing.Literal["USER"] = "USER"

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


class Message_Tool(UncheckedBaseModel):
    tool_results: typing.Optional[typing.List[ToolResult]] = None
    role: typing.Literal["TOOL"] = "TOOL"

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow


Message = typing_extensions.Annotated[
    typing.Union[Message_Chatbot, Message_System, Message_User, Message_Tool], UnionMetadata(discriminant="role")
]
